(**
 @file    convert.ml
 @brief   Implementation of automata
 @author  shinyak
 @version $Rev$

 Shinya KAWANAKA (C) 2004 All Rights Reserved.
 $Id$
*)

open Util
open Binding


module InputBinding = struct
  type r =
    | BindingList of Syntax.xml_tree list
    | InterList   of t list
  and t = r StringMap.t
end


let rec inputbinding_of_result (relname : ident) relations (result : Result.t) =
  let where_list = (List.find (fun x -> x.Syntax.name = relname) relations).Syntax.where in
  StringMap.fold (fun k v mapping ->
    match v with
      | Result.BindingRevList rev_trees ->
          let v' = InputBinding.BindingList (List.rev_map Syntax.xml_tree_of_xml_rev_tree rev_trees) in
          StringMap.add k v' mapping
      | Result.InterRevList tlst ->
          let (rel, _, k') = List.find (fun (rel, lhs, rhs) -> lhs = k) where_list in
          let v' = InputBinding.InterList 
            (List.rev_map (inputbinding_of_result rel relations) tlst)
          in
          StringMap.add k' v' mapping
  ) result StringMap.empty
;;

